#include <windows.h>
#include "hspdll.h"

//#define DEBUG

#ifdef DEBUG
#include <stdlib.h>
char __n[16];
#define MSG(x)  MessageBox(NULL, x, "loadlib.dll debug s->" #x, MB_OK)
#define iMSG(x) MessageBox(NULL, (itoa(x,__n,10),__n), "loadlib.dll debug i->" #x, MB_OK)
#define xMSG(x) MessageBox(NULL, (itoa(x,__n,16),__n), "loadlib.dll debug x->" #x, MB_OK)
#endif



//*********************************************************************
#ifdef __cplusplus
#define _ENTRN_C_ extern "C"
#else
#define _ENTRN_C_
#endif

#undef  EXPORT
#define EXPORT	_ENTRN_C_ __declspec(dllexport)
#define LOCAL	static

#define PVAL_FLAG_STR 		2
#define PVAL_FLAG_NUM 		4
#define PVAL_MODE_NORMAL	0
#define PVAL_MODE_CLONE		1
#define PVAL_MODE_ALLOCATED	2

#ifdef __GCC__
#undef  EXPORT
#define EXPORT
#endif //__GCC__

typedef enum ePARAMTYPE {NONE = 0, NUM, STR, PTR, STR_ALLOC} PARAMTYPE;

#define MAX_FUNCNAMELEN		32
#define MAX_PARAM			16

// O[oϐ
HINSTANCE	hDLL;
CHAR		szDLL[MAX_PATH];
CHAR		szFuncName[MAX_FUNCNAMELEN+1];
CHAR		szFuncType[MAX_PARAM+1];
INT			Param[MAX_PARAM];
PARAMTYPE	ParamType[MAX_PARAM];
INT			Result;
INT			*pResult;
INT			LastParamNo;

// for hsp plugin dll
#define		MAX_HSPPARAM	4
int			HspFnType;
BMSCR		*pBmScr;
CHAR		*pRefStr;
CHAR		*pDpmInfo;
CHAR		*pRgbPtr;
PVAL		*pVals[MAX_HSPPARAM];


#ifdef	MAKEHRT
#define	DllMain	loadlib_DllMain
#endif

//*********************************************************************
// entry point
//*********************************************************************
int WINAPI DllMain(HINSTANCE hInst, DWORD dwReason, LPVOID lpvReserved)
{
	if ( dwReason==DLL_PROCESS_ATTACH )
		pResult=&Result;
	return TRUE;
}


//*********************************************************************

// Param̃Zbg
LOCAL BOOL STDCALL SetParam(int param, PARAMTYPE type, int nv)
{
	if ( nv == -1 )
		LastParamNo = 0;
	else if ( nv != 0 )
		LastParamNo = nv;
	// nvw肵ĂȂƂ(nv==0)͍ŌɃp[^ݒ肵Ƃ̐lg

	if ( LastParamNo >= MAX_PARAM )
		return FALSE;

	if ( ParamType[LastParamNo] == STR_ALLOC )
		GlobalFree((HGLOBAL)Param[LastParamNo]);

	Param[LastParamNo] = param;
	ParamType[LastParamNo] = type;
	LastParamNo++;
	return TRUE;
}

// Param̏
LOCAL VOID ResetParam(void)
{
	int		i;
	LastParamNo = 0;
	for ( i = 0; i < MAX_PARAM; i++ )
		SetParam(0, NONE, i);
	LastParamNo = 0;

	// for hsp plugin dll
	HspFnType = 0;
}

// hDLL̏
LOCAL VOID DllInitialize(void)
{
	if ( hDLL != NULL )
	{
		FreeLibrary(hDLL);
		hDLL = NULL;
	}
	//DLLϐZbg
	ResetParam();
}

//*********************************************************************
// DLLZbg
//*********************************************************************
EXPORT BOOL WINAPI ll_dll(BMSCR *_no_use_, char *lpszDLLName, int p3, char *prefstr)
{	//type$16

	// for hsp plugin dll
	pRefStr = prefstr;

	if ( lstrcmp(szDLL, lpszDLLName) != 0 )
	{
		// DLLO[oϐɃRs[
		lstrcpyn(szDLL, lpszDLLName, MAX_PATH);
		// DLLZbghDLLƕϐZbg
		DllInitialize();
	}
	return 0;
}


//*********************************************************************
// ֐Zbg
//*********************************************************************
EXPORT BOOL WINAPI ll_func(BMSCR *_no_use_, char *lpszFuncName, int p3, char *pdpminfo)
{	//type$26

	// for hsp plugin dll
	pDpmInfo = pdpminfo;

	// ֐O[oϐɃRs[
	lstrcpyn(szFuncName, lpszFuncName, MAX_FUNCNAMELEN);
	// ֐ZbgϐZbg
	ResetParam();
	return 0;
}


//*********************************************************************
// ֐̃^CvZbg
//*********************************************************************
EXPORT BOOL WINAPI ll_type(BMSCR *pbmscr, char *lpszFuncType, int FnType, char *prgbptr)
{	//type$36

	// lpFuncTypeɂ "NSPPS" ̂悤ȕ񂪓Ă
	//  N:l^
	//  S(Z):^
	//  P:|C^^
	//  V:
	//  A:ȍ~̈`FbNȂ

	// ֐̃^CvO[oϐɃRs[
	lstrcpyn(szFuncType, lpszFuncType, MAX_PARAM);
	CharUpper(szFuncType);
	// ֐̃^CvZbgϐZbg
	ResetParam();

	// for hsp plugin dll
	HspFnType = FnType;
	if ( HspFnType != 0 )
	{
		CHAR		szTmp[MAX_FUNCNAMELEN+1];
		pBmScr=pbmscr;
		pRgbPtr = prgbptr;
		wsprintf(szTmp,"_%s@16",szFuncName);
		lstrcpy(szFuncName, szTmp);
	}

	return 0;
}


//*********************************************************************
// l^Cṽp[^̐ݒ
//*********************************************************************
EXPORT BOOL WINAPI ll_n(int Value, int nv, int p3, int p4)
{	//type0

	// nv͉Ԗڂ̃p[^
	if ( SetParam(Value, NUM, nv) == FALSE )
		return -1;
	return 0;
}


//*********************************************************************
// ^Cṽp[^̐ݒ
//*********************************************************************
EXPORT BOOL WINAPI ll_s(PVAL *lppval, int nv, int p3, int p4)
{	//type3

	PARAMTYPE ptype = STR;
	// nv͉Ԗڂ̃p[^
	if ( lppval->flag != PVAL_FLAG_STR )
		ptype = NONE;
	if ( SetParam((int)lppval->pt, ptype, nv) == FALSE )
		return -1;
	return 0;
}


//*********************************************************************
// ^Cṽp[^̐ݒ 2
//*********************************************************************
EXPORT BOOL WINAPI ll_z(BMSCR *_no_use_, char *pstr, int nv, int p4)
{	//type4

	char	*pstr_alloc;
	int		str_l;

	// nv͉Ԗڂ̃p[^
	str_l = lstrlen(pstr);
	pstr_alloc = GlobalAlloc(GMEM_FIXED, ++str_l);
	lstrcpy(pstr_alloc, pstr);
	if ( SetParam((int)pstr_alloc, STR_ALLOC, nv) == FALSE )
		return -1;
	return 0;
}


//*********************************************************************
// obt@^Cṽp[^̐ݒ
//*********************************************************************
EXPORT BOOL WINAPI ll_p(PVAL *lppval, int nv, int p3, int p4)
{	//type3

	// nv͉Ԗڂ̃p[^
	if ( SetParam((int)lppval->pt, PTR, nv) ==FALSE )
		return -1;

	// for hsp plugin dll
	if ( HspFnType != 0 )
		pVals[LastParamNo-1] = lppval;

	return 0;
}


//*********************************************************************
// ֐Ăяoۂpushp[^`FbN
//*********************************************************************
LOCAL INT CheckParamType(void)
{
	int i, pi, L = lstrlen(szFuncType);
	PARAMTYPE ptype;

	if ( L > MAX_PARAM )
		return -1;
	for ( i = pi = 0; i < L; i++, pi++ )
	{
		ptype = ParamType[pi];
		switch ( szFuncType[i] )
		{
			case 'V':	return 0;
			case 'N':	if ( ptype != NUM ){return -1;}	break;
			case 'S':
			case 'Z':	if ( ptype != STR && ptype != STR_ALLOC ){return -1;}	break;
			case 'P':	if ( ptype != PTR ){return -1;}	break;
			case 'A':	return MAX_PARAM;
			case ' ':	pi--; continue;
			default :	return -1;
		}
	}

	// pushp[^̐Ԃ
	return L;
}

// for hsp plugin dll
void STDCALL MakeHspParam(INT *pHspParam)
{
	int		PrmType  = (HspFnType & 0x0f);
	int		Prm4Type = (HspFnType & 0xf0);

	if( PrmType == 2
	||  PrmType == 3
	||  PrmType == 6
	||  PrmType == 7)
		CopyMemory(&pHspParam[1], Param, sizeof(int)*(MAX_HSPPARAM-1));

	switch ( PrmType )
	{
		case 2:		//p1=pBmScr
			pHspParam[0] = (INT)pBmScr;
			break;
		case 3:		//p1=pVal
			pHspParam[0] = (INT)pVals[0];
			break;
		case 6:		//p1=pBmScr
			pHspParam[0] = (INT)pBmScr;
			break;
		case 7:		//p1=pVal
			pHspParam[0] = (INT)pVals[0];
			break;
		//case 1:		//p1=void*
		//case 4:		//p1=int
		//case 5:		//p1=void*
	}

	if( Prm4Type == 0x10)		//p4=pRefStr
		pHspParam[3] = (INT)pRefStr;
	else if( Prm4Type == 0x20)	//p4=pDpmInfo
		pHspParam[3] = (INT)pDpmInfo;
	else if( Prm4Type == 0x30)	//p4=pRgbPtr
		pHspParam[3] = (INT)pRgbPtr;

	return;
}


//extern
EXPORT BOOL WINAPI ll_callfunc(INT* pParam, int np, FARPROC pFn, int p4);

//*********************************************************************
// ֐̎s
//*********************************************************************
EXPORT BOOL WINAPI ll_call(int p1, int p2, int p3, char *prefstr)
{	//type$10

	FARPROC		pFn;
	int			np;		//p[^̐

	// for hsp plugin dll
	INT			HspParam[MAX_HSPPARAM];
	INT			*pParam = Param;

	wsprintf(prefstr,"%s/%s/%s/$%X", szDLL, szFuncName, szFuncType, HspFnType);

	// np0ȏAMAX_PARAMȉB0ȂƌƁB
	if ( (np = CheckParamType()) < 0 )
		return -1;

	// for hsp plugin dll
	if ( HspFnType != 0 )
	{
		MakeHspParam(HspParam);
		pParam = HspParam;
		np = MAX_HSPPARAM;
	}

	if ( hDLL == NULL )
	{
		if ( (hDLL = LoadLibrary(szDLL)) == NULL )
			return -2;
	}

	pFn = GetProcAddress(hDLL, szFuncName);
	if ( pFn == NULL )
		return -3;

	return ll_callfunc(pParam, np, pFn, 0);
}


//*********************************************************************
// Ăяo֐̕Ԃl擾
//*********************************************************************
EXPORT BOOL WINAPI ll_ret(void *pBuf, int p2, int p3, int p4)
{	//type3

	// for hsp plugin dll
	if ( HspFnType != 0 )
		*(int*)pBuf = -(*pResult);
	else
		*(int*)pBuf = *pResult;

	return 0;
}


//*********************************************************************
// crean up
//*********************************************************************
EXPORT BOOL WINAPI ll_free(int p1, int p2, int p3, int p4)
{	//type0
	DllInitialize();
	return 0;
}


//*********************************************************************
// ϐ̃|C^擾
//*********************************************************************
EXPORT BOOL WINAPI ll_getptr(void *pBuf, int p2, int p3, int p4)
{	//type1

	*pResult=(int)pBuf;
	return 0;
}


EXPORT BOOL WINAPI ll_libload(void *phDLL, char *pDllName, int p3, int p4)
{
	HINSTANCE	hDLL;
	hDLL = LoadLibrary(pDllName);
	*(HINSTANCE*)phDLL = hDLL;
	if ( hDLL == NULL )
		return -1;
	return 0;
}

EXPORT BOOL WINAPI ll_getproc(void *pFarProc, char *pFuncName, int hDLL, int p4)
{
	FARPROC		pFunc;
	pFunc = GetProcAddress((HINSTANCE)hDLL, pFuncName);
	*(FARPROC*)pFarProc = pFunc;
	if ( pFunc == NULL )
		return -1;
	return 0;
}

EXPORT BOOL WINAPI ll_libfree(int hDLL, int p2, int p3, int p4)
{
	if ( FreeLibrary((HINSTANCE)hDLL) == 0 )
		return -1;
	return 0;
}

EXPORT BOOL WINAPI ll_peek(void *pBuf, int Address, int nPeek, int p4)
{
	if ( nPeek <= 0 )
		lstrcpy(pBuf, (char*)Address);
	else
		CopyMemory(pBuf, (void*)Address, nPeek);
	return 0;
}

EXPORT BOOL WINAPI ll_poke(void *pBuf, int Address, int nPoke, int p4)
{
	return ll_peek((void*)Address, (int)pBuf, nPoke, 0);
}

EXPORT BOOL WINAPI ll_poke1(int Poke, int Address, int p3, int p4)
{
	*(char*)Address=(char)Poke;
	return 0;
}

void STDCALL swap_byte_hl(USHORT *pus)
{
	USHORT	us;
	us = (*pus)>>8;
	*pus = (((*pus)<<8) | us);
}

void STDCALL swap_word_hl(DWORD *pd)
{
	DWORD	d;
	d = (*pd)>>16;
	*pd=((*pd<<16) | d);
}

EXPORT BOOL WINAPI ll_poke2(int Poke, int Address, int opt, int p4)
{
	if ( opt )
	{
		swap_byte_hl((USHORT*)&Poke);
	}
	*(short*)Address=(short)Poke;
	return 0;
}

EXPORT BOOL WINAPI ll_poke4(int Poke, int Address, int opt, int p4)
{
	if ( opt )
	{
		swap_byte_hl((USHORT*)&Poke);
		swap_word_hl(&Poke);
		swap_byte_hl((USHORT*)&Poke);
	}
	*(int*)Address=Poke;
	return 0;
}

EXPORT BOOL WINAPI ll_callfnv(int pProc, int p2, int p3, int p4)
{
	int	(*FuncNoArg)(void);
	FuncNoArg=(void*)pProc;
	*pResult=FuncNoArg();
	return 0;
}

EXPORT BOOL WINAPI ll_peek1(void *pBuf, int Address, int p3, int p4)
{
	int i = *(int*)Address;
	ll_poke1(i,(int)pBuf,0,0);
	return 0;
}

EXPORT BOOL WINAPI ll_peek2(void *pBuf, int Address, int p3, int p4)
{
	int i = *(int*)Address;
	ll_poke2(i,(int)pBuf,0,0);
	return 0;
}

EXPORT BOOL WINAPI ll_peek4(void *pBuf, int Address, int p3, int p4)
{
	int i = *(int*)Address;
	ll_poke4(i,(int)pBuf,0,0);
	return 0;
}

EXPORT BOOL WINAPI ll_retset(void *pVal,int p2, int p3, int p4)
{
	pResult=(int*)pVal;
	return 0;
}


BYTE htoi(BYTE c)
{
	if ( c >= '0' && c <= '9' )
		return (c - '0');
	if ( c >= 'a' && c <= 'f' )
		return (c - 'a' + 10);
	if ( c >= 'A' && c <= 'F' )
		return (c - 'A' + 10);
	return 0xff;
}

EXPORT BOOL WINAPI ll_bin(PVAL2 *pval, char *str, int off, int p4)
{
	LPBYTE	pbin = (LPBYTE)pval->pt;
	LPBYTE	pstr = (LPBYTE)str;
	LPBYTE	pstart;
	BYTE	bin, c, a;
	int		memsize;

	pbin += off;
	pstart = pbin;

	memsize = pval->len[1] << 2;
	memsize -= off;

	// "00 0A CF 00 10 F A"
	do
	{
		c = *pstr;   pstr++;
		if ( 0 == c )
			break;

		if ( c <= ' ' )
			continue;

		bin = htoi(c);
		if ( bin > 0xf )
			break;

		c = *pstr;   pstr++;

		if ( c != 0 && c > ' ' )
		{
			a = htoi(c);
			if ( a > 0xf )
				break;
			bin = ( bin << 4 ) | a;
		}

		*pbin = bin;   pbin++;
		memsize--;
	} while ( c != 0 && memsize > 0 );

	*pResult = (int)(pbin - pstart);
	return ( 0 == c ? 0 :
			 memsize > 0 ? -1 : -2 );
}

EXPORT BOOL WINAPI ll_str(PVAL2 *pval, int pmem, int nbyte, int p4)
{
	char	*pstr = pval->pt;
	LPBYTE	pbin = (LPBYTE)pmem;
	BYTE	hb, lb;
	int		memsize;

	pval->flag = 2;		//
	memsize = pval->len[1] << 2;
	memsize--;			//NULL

	for ( ;nbyte > 0; nbyte--)
	{
		hb = lb = *pbin;   pbin++;
		hb >>= 4;
		lb &= 0x0F;

		if ( hb > 9 )
			hb += 'A' - 10;
		else
			hb += '0';

		if ( lb > 9 )
			lb += 'A' - 10;
		else
			lb += '0';

		memsize -= 2;
		if ( memsize < 0 )
			break;
		*pstr = (char)hb;   pstr++;
		*pstr = (char)lb;   pstr++;
	}

	*pstr = 0;
	return ( memsize < 0 ? -2 : 0 );
}
