	.text

;#
;# LccWin32p\[Xt@C
;#
;# LccWin32̃z[y[W
;#	http://www.cs.virginia.edu/~lcc-win32/
;#

;##############################
;# _DllMain@12
;# j󃌃WX^	eax
;##############################
	.globl	_loadlib_DllMain@12
_loadlib_DllMain@12:

	.globl	_DllMain@12
_DllMain@12:
	cmpl	$1,8(%esp)
	jnz		_not_dll_process_attach
	movl	$_Result,_pResult
_not_dll_process_attach:
	xorl	%eax,%eax
	incl	%eax
	ret	$12



;##############################
;# _SetParam@12
;# j󃌃WX^	eax
;##############################
	.globl	_SetParam@12
_SetParam@12:
	pushl	%edi
	movl	16(%esp),%eax
	cmpl	$-1,%eax
	jne	_$84
	xorl	%eax,%eax
	movl	%eax,_LastParamNo
	jmp	_$85
_$84:
	testl	%eax,%eax
	jz	_$85
	movl	%eax,_LastParamNo
_$85:
	cmpl	$16,%eax
	jl	_$88
	xor	%eax,%eax
	jmp	_$83
_$88:
	movl	_LastParamNo,%eax
	cmpl	$4,_ParamType(,%eax,4)
	jne	_$90
	pushl	_Param(,%eax,4)
	call	_GlobalFree@4
_$90:
	movl	_LastParamNo,%eax
	movl	8(%esp),%edi
	movl	%edi,_Param(,%eax,4)
	movl	12(%esp),%edi
	movl	%edi,_ParamType(,%eax,4)
	incl	_LastParamNo
	xor	%eax,%eax
	inc	%eax
_$83:
	popl	%edi
	ret	$12



;##############################
;# _ResetParam
;# j󃌃WX^	eax
;##############################
_ResetParam:
	pushl	%edi
	xorl	%edi,%edi
	movl	%edi,_LastParamNo
_$94:
	pushl	%edi
	pushl	$0
	pushl	$0
	call	_SetParam@12
	incl	%edi
	cmpl	$16,%edi
	jl	_$94
	xorl	%edi,%edi
	movl	%edi,_LastParamNo

;# for hsp plugin dll
	movl	%edi,_HspFnType
	popl	%edi
	ret



;##############################
;# _DllInitialize
;# j󃌃WX^	eax
;##############################
_DllInitialize:
	cmpl	$0,_hDLL
	je	_$100
	pushl	_hDLL
	call	_FreeLibrary@4
	movl	$0,_hDLL
_$100:
	call	_ResetParam
	ret



;##############################
;# _ll_dll@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_dll@16
_ll_dll@16:
;# for hsp plugin dll
	movl	16(%esp),%eax
	movl	%eax,_pRefStr

	pushl	8(%esp)
	pushl	$_szDLL
	call	_lstrcmpA@8
	or	%eax,%eax
	je	_return_0_16_1
	pushl	$260
	pushl	12(%esp)
	pushl	$_szDLL
	call	_lstrcpynA@12
	call	_DllInitialize
	jmp _return_0_16_1



;##############################
;# _ll_func@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_func@16
_ll_func@16:
;# for hsp plugin dll
	movl	16(%esp),%eax
	movl	%eax,_pDpmInfo

	pushl	$32
	pushl	12(%esp)
	pushl	$_szFuncName
	call	_lstrcpynA@12
	call	_ResetParam
	jmp _return_0_16_1



;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;# return 0 no.1 (stdcall@16)
;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_return_0_16_1:
	xor	%eax,%eax
	ret	$16

;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;# return -1 no.1 (stdcall@16)
;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_return_m1_16_1:
	xor	%eax,%eax
	dec	%eax
	ret	$16



;##############################
;# _ll_type@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_type@16
_ll_type@16:
	pushl	$16
	pushl	12(%esp)
	pushl	$_szFuncType
	call	_lstrcpynA@12
	pushl	$_szFuncType
	call	_CharUpperA@4
	call	_ResetParam

;# for hsp plugin dll
	movl	12(%esp),%eax
	movl	%eax,_HspFnType
	test	%eax,%eax
	jz	_return_0_16_1

	movl	4(%esp),%eax
	movl	%eax,_pBmScr
	movl	16(%esp),%eax
	movl	%eax,_pRgbPtr

	pushl	%ebp
	movl	%esp,%ebp
	subl	$36,%esp
	pushl	%esi
	leal	-36(%ebp),%esi

	pushl	$_szFuncName
	pushl	$_$hsp_plugin_fname
	pushl	%esi
	call	_wsprintfA
	addl	$12,%esp

	pushl	%esi
	pushl	$_szFuncName
	call	_lstrcpyA@8

	popl	%esi
	movl	%ebp,%esp
	popl	%ebp

	jmp _return_0_16_1



;##############################
;# _ll_n@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_n@16
_ll_n@16:
	pushl	8(%esp)
	pushl	$1
	pushl	12(%esp)
	call	_SetParam@12
	or	%eax,%eax
	jne	_return_0_16_2
;#	movl	$-1,%eax
	jmp _return_m1_16_2




;##############################
;# _ll_s@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_s@16
_ll_s@16:
	pushl	%esi
	movl	8(%esp),%esi
	movl	$2,%eax
	cmpw	$2,(%esi)
	je	_$118
	xorl	%eax,%eax
_$118:
	pushl	12(%esp)
	pushl	%eax
	pushl	16(%esi)
	call	_SetParam@12
	popl	%esi
	or	%eax,%eax
	jne	_return_0_16_2
	jmp _return_m1_16_2




;##############################
;# _ll_z@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_z@16
_ll_z@16:
	pushl	%esi
	movl	12(%esp),%esi
	pushl	%esi
	call	_lstrlenA@4
	incl	%eax
	pushl	%eax
	pushl	$0
	call	_GlobalAlloc@8
	pushl	%esi
	pushl	%eax
	movl	%eax,%esi
	call	_lstrcpyA@8
	pushl	16(%esp)
	pushl	$4
	pushl	%esi
	call	_SetParam@12
	popl	%esi
	or	%eax,%eax
	jne	_return_0_16_2
	jmp _return_m1_16_2



;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;# return 0 no.2 (stdcall@16)
;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_return_0_16_2:
	xor	%eax,%eax
	ret	$16

;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;# return -1 no.2 (stdcall@16)
;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_return_m1_16_2:
	xor	%eax,%eax
	dec	%eax
	ret	$16



;##############################
;# _ll_p@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_p@16
_ll_p@16:
	movl	4(%esp),%eax
	pushl	8(%esp)
	pushl	$3
	pushl	16(%eax)
	call	_SetParam@12
	or	%eax,%eax
	jz	_return_m1_16_2

_$133:
;# for hsp plugin dll
	cmpl	$0,_HspFnType
	je	_no_need_pVals
	movl	_LastParamNo,%eax
	movl	4(%esp),%ecx
	movl	%ecx,_pVals-4(%eax,4)
_no_need_pVals:

	jmp _return_0_16_2



;##############################
;# _CheckParamType
;# j󃌃WX^	eax
;##############################
_CheckParamType:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%ebx
	pushl	%esi
	pushl	%edi
	pushl	$_szFuncType
	call	_lstrlenA@4
	movl	%eax,-4(%ebp)
	cmpl	$16,%eax
	jle	_$138
;#	movl	$-1,%eax
	xorl	%eax,%eax
	decl	%eax

	jmp	_$137
_$138:
	xorl	%esi,%esi
	movl	%esi,%edi
	jmp	_$143
_$140:
	movl	_ParamType(,%esi,4),%ebx
	movsbl	_szFuncType(,%edi),%eax
	;# N
	cmpb	$78,%al
	je	_$148
	;# P
	cmpb	$80,%al
	je	_$154
	;# S
	cmpb	$83,%al
	je	_$151
	jg	_$160
	;# space
	cmpl	$32,%eax
	je	_$158
	jl	_$144
	;# A
	cmpl	$65,%eax
	je	_$157
	jmp	_$144
_$160:
	;# V
	cmpl	$86,%eax
	je	_$147
	jl	_$144
	;# Z
	cmpl	$90,%eax
	je	_$151
	jmp	_$144
_$147:
	xor	%eax,%eax
	jmp	_$137
_$148:
	cmpl	$1,%ebx
	je	_$141
;#	movl	$-1,%eax
	xorl	%eax,%eax
	decl	%eax

	jmp	_$137
_$151:
	cmpl	$2,%ebx
	je	_$141
	cmpl	$4,%ebx
	je	_$141
;#	movl	$-1,%eax
	xorl	%eax,%eax
	decl	%eax

	jmp	_$137
_$154:
	cmpl	$3,%ebx
	je	_$141
;#	movl	$-1,%eax
	xorl	%eax,%eax
	decl	%eax

	jmp	_$137
_$157:
	movl	$16,%eax
	jmp	_$137
_$158:
	decl	%esi
	jmp	_$141
_$144:
;#	movl	$-1,%eax
	xorl	%eax,%eax
	decl	%eax

	jmp	_$137
_$141:
	incl	%edi
	incl	%esi
_$143:
	cmpl	-4(%ebp),%edi
	jl	_$140
	movl	-4(%ebp),%eax
_$137:
	popl	%edi
	popl	%esi
	popl	%ebx
	leave
	ret



;##############################
;# _ll_call@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_call@16
_ll_call@16:
	pushl	%ebp
	movl	%esp,%ebp
	subl	$16,%esp
	pushl	%esi
	pushl	%ebx
	pushl	%edi
	movl	$_Param,%edi

	pushl	_HspFnType
	pushl	$_szFuncType
	pushl	$_szFuncName
	pushl	$_szDLL
	pushl	$_$ll_call_return_str
	pushl	20(%ebp)
	call	_wsprintfA
	addl	$24,%esp
	call	_CheckParamType
	movl	%eax,%esi
	or	%eax,%eax
	jge	_$167
;#	movl	$-1,%eax
	xor	%eax,%eax
	dec %eax
	jmp	_$165

_$167:

;# for hsp plugin dll
;# *************MakeHspParam start*************
	movl _HspFnType,%eax
	testl %eax,%eax
	je __L154
	movl %eax,%ebx
	andl $15,%ebx
	movl %eax,%ecx
	andl $240,%ecx
	leal -2(%ebx),%eax
	cmpl $1,%eax
	jbe __L155
	cmpl $6,%ebx
	je __L155
	cmpl $7,%ebx
	jne __L156
__L155:
	pushl	%ecx
	pushl	%esi
	pushl	%edi
	movl $6,%ecx
	movl $_Param,%esi
	;# HspParam
	leal -12(%ebp),%edi
	rep
	movsw
	popl	%edi
	popl	%esi
	popl	%ecx
__L156:
	cmpl $3,%ebx
	je __L162
	jg __L158
	cmpl $2,%ebx
	je __L159
	jmp __L163
__L158:
	cmpl $6,%ebx
	je __L161
	cmpl $7,%ebx
	je __L162
	jmp __L163
__L159:
	movl _pBmScr,%eax
	jmp __L174
__L161:
	movl _pBmScr,%eax
	jmp __L174
__L162:
	movl _pVals,%eax
__L174:
	;# HspParam
	movl %eax,-16(%ebp)
__L163:
	cmpl $16,%ecx
	jne __L164
	movl _pRefStr,%eax
	jmp __L175
__L164:
	cmpl $32,%ecx
	jne __L166
	movl _pDpmInfo,%eax
	jmp __L175
__L166:
	cmpl $48,%ecx
	jne __L169
	movl _pRgbPtr,%eax
__L175:
	;# HspParam
	movl %eax,-4(%ebp)
__L169:
	;# HspParam
	leal -16(%ebp),%edi
	movl $4,%esi
__L154:
;# *************MakeHspParam end  *************



	cmpl	$0,_hDLL
	jne	_$169
	pushl	$_szDLL
	call	_LoadLibraryA@4
	movl	%eax,_hDLL
	or	%eax,%eax
	jne	_$169
	movl	$-2,%eax
	jmp	_$165
_$169:
	pushl	$_szFuncName
	pushl	_hDLL
	call	_GetProcAddress@8
	or	%eax,%eax
	jne	_$173
	movl	$-3,%eax
	jmp	_$165
_$173:
	pushl	$0
	pushl	%eax
	pushl	%esi
	pushl	%edi
	call	_ll_callfunc@16
	xor	%eax,%eax
_$165:
	popl	%edi
	popl	%ebx
	popl	%esi
	leave
	ret	$16

	.extern	_ll_callfunc@16



;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;# return 0 no.3 (stdcall@16)
;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_return_0_16_3:
	xor	%eax,%eax
	ret	$16

;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;# return -1 no.3 (stdcall@16)
;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_return_m1_16_3:
	xor	%eax,%eax
	dec	%eax
	ret	$16



;##############################
;# _ll_ret@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_ret@16
_ll_ret@16:
	movl	4(%esp),%eax
;# for hsp plugin dll
	movl	_pResult,%ecx
	movl	(%ecx),%ecx
	cmpl $0,_HspFnType
	je _no_neg
	neg	%ecx
_no_neg:
	movl	%ecx,(%eax)
	jmp	_return_0_16_3


;##############################
;# _ll_free@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_free@16
_ll_free@16:
	call	_DllInitialize
	jmp	_return_0_16_3



;##############################
;# _ll_getptr@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_getptr@16
_ll_getptr@16:
	movl	4(%esp),%eax
	movl	_pResult,%ecx
	movl	%eax,(%ecx)
	jmp	_return_0_16_3



;##############################
;# _ll_libload@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_libload@16
_ll_libload@16:
	pushl	8(%esp)
	call	_LoadLibraryA@4
	movl	4(%esp),%ecx
	movl	%eax,(%ecx)
	test	%eax,%eax
	jne	_return_0_16_3
	jmp	_return_m1_16_3



;##############################
;# _ll_getproc@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_getproc@16
_ll_getproc@16:
	pushl	8(%esp)
	pushl	16(%esp)
	call	_GetProcAddress@8
	movl	4(%esp),%ecx
	movl	%eax,(%ecx)
	test	%eax,%eax
	jne	_return_0_16_3
	jmp	_return_m1_16_3



;##############################
;# _ll_libfree@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_libfree@16
_ll_libfree@16:
	pushl	4(%esp)
	call	_FreeLibrary@4
	test	%eax,%eax
	jnz	_return_0_16_4
	jmp	_return_m1_16_4



;##############################
;# _ll_peek@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_peek@16
_ll_peek@16:
	pushl	%edi
	pushl	%esi
	movl	12(%esp),%edi
	movl	16(%esp),%esi
	movl	20(%esp),%ecx
	testl	%ecx,%ecx
	jg	_$211
	pushl	%edi
	movl	%esi,%edi
	xorl	%eax,%eax
	orl	$-1,%ecx
	repne
	scasb
	notl	%ecx
	popl	%edi
_$211:
	testl	$1,%ecx
	jz	_$210
	rep
	movsb
	jmp	_$209
_$210:
	shrl	%ecx
	rep
	movsw
	jmp	_$209
_$209:
	popl	%esi
	popl	%edi
	jmp	_return_0_16_4



;##############################
;# _ll_poke@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_poke@16
_ll_poke@16:
	pushl	$0
	pushl	16(%esp)
	pushl	12(%esp)
	pushl	20(%esp)
	call	_ll_peek@16
	jmp	_return_0_16_4



;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;# return -1 no.4 (stdcall@16)
;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_return_m1_16_4:
	xor	%eax,%eax
	dec	%eax
	ret	$16

;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;# return 0 no.4 (stdcall@16)
;# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_return_0_16_4:
	xor	%eax,%eax
	ret	$16



;##############################
;# _ll_poke1@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_poke1@16
_ll_poke1@16:
	movl	4(%esp),%eax
	movl	8(%esp),%ecx
	movb	%eax,(%ecx)
	jmp	_return_0_16_4



;##############################
;# _ll_poke2@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_poke2@16
_ll_poke2@16:
	movl	4(%esp),%eax
	movl	12(%esp),%ecx
	testl	%ecx,%ecx
	jz	_no_swap_p2
	xchgb	%ah,%al
_no_swap_p2:
	movl	8(%esp),%ecx
	movw	%eax,(%ecx)
	jmp	_return_0_16_4



;##############################
;# _ll_poke4@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_poke4@16
_ll_poke4@16:
	movl	4(%esp),%eax
	movl	12(%esp),%ecx
	testl	%ecx,%ecx
	jz	_no_swap_p4
	xchgb	%ah,%al
	ror	$16,%eax
	xchgb	%ah,%al
_no_swap_p4:
	movl	8(%esp),%ecx
	movl	%eax,(%ecx)
	jmp	_return_0_16_4



;##############################
;# _ll_callfnv@16
;# j󃌃WX^	eax
;##############################
	.globl	_ll_callfnv@16
_ll_callfnv@16:
	call	*4(%esp)
	movl	_pResult,%ecx
	movl	%eax,(%ecx)
	jmp	_return_0_16_4


;##############################
;# _ll_peek1@16
;# _ll_peek2@16
;# _ll_poke4@16
;# j󃌃WX^	eax,ecx
;##############################
	.globl	_ll_peek1@16
	.globl	_ll_peek2@16
	.globl	_ll_peek4@16
_ll_peek1@16:
	movl	$_ll_poke1@16,%ecx
	jmp _common_peek_n
_ll_peek2@16:
	movl	$_ll_poke2@16,%ecx
	jmp _common_peek_n
_ll_peek4@16:
	movl	$_ll_poke4@16,%ecx
_common_peek_n:
	xorl	%eax,%eax
	push	%eax
	push	%eax
	push	12(%esp)
	movl	20(%esp),%eax
	push	(%eax)
	call %ecx
	jmp	_return_0_16_4

	.globl	_ll_retset@16
_ll_retset@16:
	movl	4(%esp),%eax
	movl	%eax,_pResult
	jmp	_return_0_16_4

;# "%s/%s/%s/$%X"
_$ll_call_return_str:
	.byte	37,115,47,37,115,47,37,115,47,36,37,88,0

;# "_%s@16"
_$hsp_plugin_fname:
	.byte	95,37,115,64,49,54,0


;##############################
;# _bin
;# j󃌃WX^	eax
;##############################
_bin:
	subb $0x30, %al        ;;# '0'
	cmpb $9, %al
	jbe _ret
	addb $0x30, %al        ;;# '0'
	andb $0xDF, %al        ;;#(not 20h)
	subb $0x41, %al        ;;# 'A'
	cmpb $5, %al
	ja	_ret_err
	addb $10, %al
_ret:
	ret
_ret_err:
	xorb %al, %al
	decb %al
	ret

;##############################
;# _ll_bin@16
;# j󃌃WX^	eax,ecx,edx
;##############################
.globl _ll_bin@16
_ll_bin@16:
	push %edi
	push %esi
	mov 0x0C(%esp), %edi    ;;# p1 pval2
	mov 0x10(%esp), %esi    ;;# p2 str
	mov 0x14(%esp), %eax    ;;# p3 off

	movl 8(%edi), %ecx      ;;# pvalȂmovswl 6(%edi), %ecx
	shl  $2, %ecx
	movl 0x1C(%edi), %edi   ;;# pvalȂmovl 0x10(%edi), %edi

	add	%eax, %edi
	sub %eax, %ecx
	push %edi               ;;# p1 + p3

	xor	%eax, %eax
tobin:

	;;# HIGH BYTE
	movb (%esi), %al
	inc	%esi

	movb %al, %dh
	testb %al,%al
	je	end_tobin

	cmpb $0x20, %al
	jbe	tobin

	call	_bin
	cmpb $0xF, %al
	ja	end_tobin

	mov	%al, %dl

	;;# LOW BYTE
	movb (%esi), %al
	inc	%esi
	movb %al, %dh

	testb %al, %al
	je	_write

	cmpb $0x20, %al
	jbe	_write

	call	_bin
	cmpb $0xF, %al
	ja	end_tobin

	shl	$4, %dl
	or	%al, %dl
_write:

	dec %ecx
	jl end_tobin

	movb %dl, (%edi)
	inc %edi

	testb %dh, %dh
	jne tobin

end_tobin:
	xor %eax,%eax
	testb %dh,%dh
	je	ll_bin_ret

	test %ecx,%ecx
	setgeb %al
	add $-2, %eax

ll_bin_ret:
	pop %esi                ;;# p1 + p3
	sub	%esi, %edi
	mov	_pResult, %esi
	mov %edi, (%esi)

	pop	%esi
	pop	%edi
	ret	$16


;##############################
;# _ll_str@16
;# j󃌃WX^	eax,edx
;##############################
.globl _ll_str@16
_ll_str@16:
	push %edi
	push %esi
	mov	0x0C(%esp), %edi      ;;#p1 pval2
	mov	0x10(%esp), %esi      ;;#p2 pmem
	mov	0x14(%esp), %ecx      ;;#p3 nbyte

	movw $2,(%edi)
	movl 8(%edi), %edx        ;;#pvalȂmovswl 6(%edi), %edx
	movl 0x1C(%edi), %edi     ;;#pvalȂmovl 0x10(%edi), %edi
	shl $2, %edx
	dec %edx

	test %ecx,%ecx
	jle end_tostr

tostr:
	movb (%esi), %ah
	movb %ah, %al
	andb $0xF, %ah
	shrb $4, %al

	addw $0x3030, %ax         ;;# ( '0' << 8 ) | '0'

	cmpb $0x39, %al           ;;#'9'
	jbe _hb_below10
	addb $7, %al              ;;#('A'-10-'0') => 65-10-48=7
_hb_below10:

	cmpb $0x39, %ah           ;;#'9'
	jbe _lb_below10
	addb $7, %ah              ;;#('A'-10-'0') => 65-10-48=7
_lb_below10:

	dec %edx
	dec %edx
	jl  end_tostr

	movw %ax, (%edi)
	inc %esi
	inc %edi
	inc %edi
	dec %ecx
	jg tostr

end_tostr:
	xor %eax,%eax
	movb %al, (%edi)
	test %edx,%edx
	setgeb %al
	dec %eax
	and $-2, %eax
	pop %esi
	pop %edi
	ret $16



;############################################################
;############################################################
;############################################################
	.bss

;# for hsp plugin dll
	.globl	_pVals
	.align	2
	.type	_pVals,object
	.comm	_pVals,16
	.globl	_pRgbPtr
	.align	2
	.type	_pRgbPtr,object
	.comm	_pRgbPtr,4
	.globl	_pDpmInfo
	.align	2
	.type	_pDpmInfo,object
	.comm	_pDpmInfo,4
	.globl	_pRefStr
	.align	2
	.type	_pRefStr,object
	.comm	_pRefStr,4
	.globl	_pBmScr
	.align	2
	.type	_pBmScr,object
	.comm	_pBmScr,4
	.globl	_HspFnType
	.align	2
	.type	_HspFnType,object
	.comm	_HspFnType,4


	.globl	_hDLL
	.align	2
	.type	_hDLL,object
	.comm	_hDLL,4
	.globl	_LastParamNo
	.align	2
	.type	_LastParamNo,object
	.comm	_LastParamNo,4
	.globl	_Result
	.align	2
	.type	_Result,object
	.comm	_Result,4
	.globl	_pResult
	.align	2
	.type	_pResult,object
	.comm	_pResult,4
	.globl	_ParamType
	.align	2
	.type	_ParamType,object
	.comm	_ParamType,64
	.globl	_Param
	.align	2
	.type	_Param,object
	.comm	_Param,64
	.globl	_szFuncType
	.type	_szFuncType,object
	.comm	_szFuncType,17
	.globl	_szFuncName
	.type	_szFuncName,object
	.comm	_szFuncName,33
	.globl	_szDLL
	.type	_szDLL,object
	.comm	_szDLL,260
	.extern	_GlobalFree@4
	.extern	_GlobalAlloc@8
	.extern	_GetProcAddress@8
	.extern	_FreeLibrary@4
	.extern	_CharUpperA@4
	.extern	_wsprintfA
	.extern	_LoadLibraryA@4
	.extern	_lstrlenA@4
	.extern	_lstrcpyA@8
	.extern	_lstrcpynA@12
	.extern	_lstrcmpA@8
;#	.data
;# _$166:
;#	.byte	37,115,47,37,115,47,37,115,0

	.section	.drectve
;#-export:_ll_dll@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 100, 108, 108, 64, 49, 54, 32
;#-export:_ll_func@16 
.byte  45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 102, 117, 110, 99, 64, 49, 54, 32
;#-export:_ll_type@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 116, 121, 112, 101, 64, 49, 54, 32
;#-export:_ll_n@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 110, 64, 49, 54, 32
;#-export:_ll_s@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 115, 64, 49, 54, 32
;#-export:_ll_z@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 122, 64, 49, 54, 32
;#-export:_ll_p@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 64, 49, 54, 32
;#-export:_ll_call@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 99, 97, 108, 108, 64, 49, 54, 32
;#-export:_ll_ret@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 114, 101, 116, 64, 49, 54, 32
;#-export:_ll_free@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 102, 114, 101, 101, 64, 49, 54, 32

;#-export:_ll_getptr@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 103, 101, 116, 112, 116, 114, 64, 49, 54, 32
;#-export:_ll_libload@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 108, 105, 98, 108, 111, 97, 100, 64, 49, 54, 32
;#-export:_ll_getproc@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 103, 101, 116, 112, 114, 111, 99, 64, 49, 54, 32
;#-export:_ll_libfree@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 108, 105, 98, 102, 114, 101, 101, 64, 49, 54, 32
;#-export:_ll_peek@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 101, 101, 107, 64, 49, 54, 32
;#-export:_ll_poke@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 111, 107, 101, 64, 49, 54, 32

;#-export:_ll_poke1@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 111, 107, 101, 49, 64, 49, 54, 32
;#-export:_ll_poke2@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 111, 107, 101, 50, 64, 49, 54, 32
;#-export:_ll_poke4@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 111, 107, 101, 52, 64, 49, 54, 32

;#-export:_ll_callfnv@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 99, 97, 108, 108, 102, 110, 118, 64, 49, 54, 32

;#-export:_ll_peek1@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 101, 101, 107, 49, 64, 49, 54, 32

;#-export:_ll_peek2@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 101, 101, 107, 50, 64, 49, 54, 32

;#-export:_ll_peek4@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 112, 101, 101, 107, 52, 64, 49, 54, 32

;#-export:_ll_retset@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 114, 101, 116, 115, 101, 116, 64, 49, 54, 32

;#-export:_ll_callfunc@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 99, 97, 108, 108, 102, 117, 110, 99, 64, 49, 54, 32

;#-export:_ll_bin@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 98, 105, 110, 64, 49, 54, 32

;#-export:_ll_str@16 
.byte 45, 101, 120, 112, 111, 114, 116, 58, 95, 108, 108, 95, 115, 116, 114, 64, 49, 54, 32

