#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "hspdll.h"
#include "hsp2lib.h"

#include "loadlib_hrt.h"

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpszCmd, int nCmdShow)
{
	int stat;
	HSPCMD_INFO info;

	info.ver = loadlib_Ver;
	info.hspfnc = loadlib_hspfnc;
	strcpy( info.name, loadlib_Name );
	HSPSetFunc( &info );

	/* DLL֐Ăяo */
	loadlib_DllMain( hInstance, DLL_PROCESS_ATTACH, NULL );

	/* HSPCĂяo */
	stat = HSPWinMain( hInstance, hPrevInst, lpszCmd, nCmdShow );

	/* DLLI֐Ăяo */
	loadlib_DllMain( hInstance, DLL_PROCESS_DETACH, NULL );

	return stat;
}
